package com.cit.sellfan.ui.pannelli;

import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.cit.sellfan.business.VariabiliGlobali;
import com.vaadin.data.Validator;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.DateField;
import com.vaadin.ui.Panel;
import com.xdev.ui.XdevGridLayout;
import com.xdev.ui.XdevLabel;
import com.xdev.ui.XdevTextField;

public class pannelloPreventivoEditNew extends Panel {
	private VariabiliGlobali l_VG;
	private final DateField textDataPreventivo = new DateField();
	public boolean newMode = true;
	Validator noSpecChar = new Validator() {
		private static final long serialVersionUID = 1L;
		@Override
		public void validate(final Object value) throws InvalidValueException {
			final Pattern p = Pattern.compile("^[a-zA-Z0-9 ]*$");
			final Matcher m = p.matcher(value.toString());
			if (!m.find()) {
				throw new InvalidValueException("Only letters and numbers admitted");
			}
			}
	};
	/**
	 * 
	 */
	public pannelloPreventivoEditNew() {
		super();
		this.initUI();
		this.textDataPreventivo.setDateFormat("dd/MM/yyyy");
		this.textDataPreventivo.setSizeUndefined();
		this.gridLayout.replaceComponent(this.textDataPreventivoGosth, this.textDataPreventivo);
		this.textDataPreventivo.setValue(new Date());
	}

	
	public void setVariabiliGlobali(final VariabiliGlobali variabiliGlobali) {
		this.l_VG = variabiliGlobali;
		Nazionalizza();
	}
	
	public void Nazionalizza() {
		//this.labelID.setValue(this.l_VG.utilityTraduzioni.TraduciStringa("Codice"));
		this.labelCodiceOfferta.setValue(this.l_VG.utilityTraduzioni.TraduciStringa("Codice Offerta"));
		this.labelCodiceOrdine.setValue(this.l_VG.utilityTraduzioni.TraduciStringa("Codice Ordine"));
		this.labelDataPreventivo.setValue(this.l_VG.utilityTraduzioni.TraduciStringa("Data Preventivo"));
		this.textFieldCodiceOfferta.setInputPrompt(this.l_VG.utilityTraduzioni.TraduciStringa("Solo spazi lettere e numeri"));
	}
	
	public void init() {
		if (!this.newMode) {
			//this.labelIDVal.setValue(Integer.toString(this.l_VG.preventivoCurrent.IDPreventivo));
			this.textFieldCodiceOfferta.setValue(this.l_VG.preventivoCurrent.NumOfferta);
			this.textFieldCodiceOrdine.setValue(this.l_VG.preventivoCurrent.NumOrdine);
			this.textDataPreventivo.setVisible(false);
			this.labelDataPreventivo.setVisible(false);
			this.textDataPreventivo.setValue(this.l_VG.preventivoCurrent.Data);

		}
	}
	
	public void getValues() {
		final String replacedString = this.textFieldCodiceOfferta.getValue().replaceAll("[^0-9A-Za-z ]", "");
		this.l_VG.preventivoCurrent.NumOfferta = replacedString;
		this.l_VG.preventivoCurrent.NumOrdine = this.textFieldCodiceOrdine.getValue();
		this.l_VG.preventivoCurrent.Data = this.textDataPreventivo.getValue();
	}
	
	
	public boolean validate() {
		final Pattern p = Pattern.compile("^[a-zA-Z0-9 ]*$");
		final Matcher m = p.matcher(this.textFieldCodiceOfferta.getValue());
		return m.find();
		}
	
	/*
	 * WARNING: Do NOT edit!<br>The content of this method is always regenerated by
	 * the UI designer.
	 */
	// <generated-code name="initUI">
	private void initUI() {
		this.gridLayout = new XdevGridLayout();
		//this.labelID = new XdevLabel();
		//this.labelIDVal = new XdevLabel();
		this.labelCodiceOfferta = new XdevLabel();
		this.textFieldCodiceOfferta = new XdevTextField();
		this.labelCodiceOrdine = new XdevLabel();
		this.textFieldCodiceOrdine = new XdevTextField();
		this.labelDataPreventivo = new XdevLabel();
		this.textDataPreventivoGosth = new XdevTextField();
			
		//this.labelID.setValue("Codice");
		//this.labelIDVal.setValue("-1");
		this.labelCodiceOfferta.setValue("Codice Offerta");
		this.labelCodiceOrdine.setValue("Codice Ordine");
		this.labelDataPreventivo.setValue("Data Preventivo");
	
		this.gridLayout.setColumns(2);
		this.gridLayout.setRows(5);
		//this.labelID.setSizeUndefined();
		//this.gridLayout.addComponent(this.labelID, 0, 0);
		//this.gridLayout.setComponentAlignment(this.labelID, Alignment.TOP_RIGHT);
		//this.labelIDVal.setWidth(100, Unit.PERCENTAGE);
		//this.labelIDVal.setHeight(-1, Unit.PIXELS);
		//this.gridLayout.addComponent(this.labelIDVal, 1, 0);
		this.labelCodiceOfferta.setSizeUndefined();
		this.gridLayout.addComponent(this.labelCodiceOfferta, 0, 0);
		this.gridLayout.setComponentAlignment(this.labelCodiceOfferta, Alignment.TOP_RIGHT);
		this.textFieldCodiceOfferta.setWidth(200, Unit.PIXELS);
		this.textFieldCodiceOfferta.setHeight(-1, Unit.PIXELS);
		this.gridLayout.addComponent(this.textFieldCodiceOfferta, 1, 0);
		this.labelCodiceOrdine.setSizeUndefined();
		this.gridLayout.addComponent(this.labelCodiceOrdine, 0, 1);
		this.gridLayout.setComponentAlignment(this.labelCodiceOrdine, Alignment.TOP_RIGHT);
		this.textFieldCodiceOrdine.setWidth(200, Unit.PIXELS);
		this.textFieldCodiceOrdine.setHeight(-1, Unit.PIXELS);
		this.gridLayout.addComponent(this.textFieldCodiceOrdine, 1, 1);
		this.labelDataPreventivo.setSizeUndefined();
		this.gridLayout.addComponent(this.labelDataPreventivo, 0, 2);
		this.gridLayout.setComponentAlignment(this.labelDataPreventivo, Alignment.TOP_RIGHT);
		this.textDataPreventivoGosth.setSizeUndefined();
		this.gridLayout.addComponent(this.textDataPreventivoGosth, 1, 2);
		this.gridLayout.setColumnExpandRatio(0, 10.0F);
		this.gridLayout.setColumnExpandRatio(1, 10.0F);
		this.gridLayout.setSizeUndefined();
		this.setContent(this.gridLayout);
		this.setSizeUndefined();
		
	} // </generated-code>
	


	// <generated-code name="variables">
	private XdevGridLayout gridLayout;
	private XdevLabel labelCodiceOfferta, labelCodiceOrdine, labelDataPreventivo;
	private XdevTextField textFieldCodiceOfferta, textFieldCodiceOrdine, textDataPreventivoGosth; // </generated-code>


}
